<?php

$larg=700;
$haut=400;

$image=@imagecreatetruecolor($larg,$haut) or die ("Impossible d'initialiser la librairie GD");
$bg=imagecolorallocate($image,255,255,255);
imagefill($image,0,0,$bg);

//Dgrad arrire
for ($y=0;$y<$haut;$y++) {
	$var=(-255/$haut)*$y+255;
	$color=allocate($image,$var,255,$var);
	$yline=$y+($haut/2);
	imageline($image,0,$yline,$larg,$yline,$color);
}


//Cercles arc en ciel
$y=250; $pasy=0.5;
$r=255;$v=0;$b=0;

while ($v<248) {
	$color=allocate($image,$r,$v,$b);
	dessinearc($image,$larg/2,$haut,$y,$color);
	$y+=$pasy;
	$r=$r-8;
	$v=$v+8;
}

while ($b<248) {
	$color=allocate($image,$r,$v,$b);
	dessinearc($image,$larg/2,$haut,$y,$color);
	$y+=$pasy;
	$v=$v-8;
	$b=$b+8;
}

while ($r<248) {
	$color=allocate($image,$r,$v,$b);
	dessinearc($image,$larg/2,$haut,$y,$color);
	$y+=$pasy;
	$b=$b-8;
	$r=$r+8;
}



//Texte

$r=$y+50;
$place=0;
$chaine=((isset($_GET['texte'])) ? $_GET['texte'] : "Taste the rainbow !");
$inc=3;
$deb=270-(strlen($chaine)/2)*$inc;

for ($pos=$deb;$pos<=360;$pos+=$inc) {
	$posrad=(M_PI*$pos)/180;
	$posx=$r*cos($posrad)+$larg/2;
	$posy=$r*sin($posrad)+$haut;
	$angle=-$pos-180+90;
	$lettre=substr($chaine,$place,1);

	if (!isset($_GET['red']) && !isset ($_GET['green']) && !isset($_GET['blue'])) {
		$composante=mt_rand(0,1)*255;
		$p=mt_rand(1,5);
		$red=0; $v=0; $b=0;
		if ($p==1) $red=255;
		if ($p==2) $v=255;
		if ($p==3) $b=255;
		if ($p==4) {$red=255; $b=255;}
		if ($p==5) {$b=255; $v=255;}
		$color=allocate($image,$red,$v,$b);
	}
	else
		$color=allocate($image,$_GET['red'],$_GET['green'],$_GET['blue']);

	if ($place<strlen($chaine))
		imagettftext ($image,20,$angle,$posx,$posy,$color,"./times.ttf",$lettre) or die("Error opening font");
	$place++;
}

/*
verdana
arial
times
*/

define('IN_IMAGE', true);
include("image_fin.php");
header("Content-type:image/gif");
imagegif($image);
imagedestroy($image);


function dessinearc($im,$cx,$cy,$r,$colorate) {
$pas=1/6;
	for($angle=180;$angle<=360;$angle+=$pas) {
		$anglerad=(M_PI*$angle)/180;
		$px=$r*cos($anglerad)+$cx;
		$py=$r*sin($anglerad)+$cy;
		imagesetpixel($im,$px,$py,$colorate);
	}
}

function allocate($im,$r,$v,$b) {
	$colorate=imagecolorexact($im,$r,$v,$b);
	if ($colorate==-1) $colorate=imagecolorallocate($im,$r,$v,$b);
	return($colorate);
}
?>
