<?php

$larg=700;
$haut=400;

$image=@imagecreatetruecolor($larg,$haut) or die ("Impossible d'initialiser la librairie GD");
$bg=imagecolorallocate($image,255,255,255);
imagefill($image,0,0,$bg);

//Dgrad arrire
for ($y=0;$y<$haut;$y++) {
	$var=(-255/$haut)*$y+255;
	$color=allocate($image,$var,255,$var);
	$yline=$y+($haut/2);
	imageline($image,0,$yline,$larg,$yline,$color);
}


//Cercles arc en ciel
$y=250; $pasy=0.5;
$r=255;$v=0;$b=0;

while ($v<248) {
	$color=allocate($image,$r,$v,$b);
	dessinearc($image,$larg/2,$haut,$y,$color);
	$y+=$pasy;
	$r=$r-8;
	$v=$v+8;
}

while ($b<248) {
	$color=allocate($image,$r,$v,$b);
	dessinearc($image,$larg/2,$haut,$y,$color);
	$y+=$pasy;
	$v=$v-8;
	$b=$b+8;
}

while ($r<248) {
	$color=allocate($image,$r,$v,$b);
	dessinearc($image,$larg/2,$haut,$y,$color);
	$y+=$pasy;
	$b=$b-8;
	$r=$r+8;
}

define('IN_IMAGE', true);
include("image_fin.php");
header("Content-type: image/gif");
imagegif($image);
imagedestroy($image);


function dessinearc($im,$cx,$cy,$r,$colorate) {
	$pas=1/6;
	for($angle=180;$angle<=360;$angle+=$pas) {
		$anglerad=(M_PI*$angle)/180;
		$px=$r*cos($anglerad)+$cx;
		$py=$r*sin($anglerad)+$cy;
		imagesetpixel($im,$px,$py,$colorate);
	}
}

function allocate($im,$r,$v,$b) {
	$colorate=imagecolorexact($im,$r,$v,$b);
	if ($colorate==-1)
		$colorate=imagecolorallocate($im,$r,$v,$b);
	return($colorate);
}
?>
